'#####################################################################
'# Prozeduren zum Anlegen eines Jahreskalenders mit Feiertagsanzeige #
'# Autor: Hans W. Herber - hans@herber.de - http://www.herber.de     #
'# Erstellt im Februar 2001                                          #
'#####################################################################

Sub JahresKalender()
    Dim kJahr$
    Application.ScreenUpdating = False
    kJahr = InputBox("Kalenderjahr:", , Year(Date))
    If kJahr = "" Then Exit Sub
    Worksheets("Feiertage").Range("C1") = CInt(kJahr)
    Call BlattAnlegen
    Call JahrAnlegen(kJahr)
    Call Wochenende
    Call Feiertage(ThisWorkbook.Worksheets("Feiertage"))
    Range("A1").Select
End Sub

Private Sub BlattAnlegen()
    Dim i%
    Workbooks.Add
    Application.DisplayAlerts = False
    For i = 1 To Sheets.Count - 1
        Sheets(1).Delete
    Next i
    Application.DisplayAlerts = True
    Range("A1") = "Datum"
    Range("C1") = "Eintragung"
    With Range("A1:C1")
        With .Font
            .Bold = True
            .Size = 10
            .ColorIndex = 6
        End With
        .Interior.ColorIndex = 11
    End With
End Sub

Private Sub JahrAnlegen(kJahr)
    Dim n%
    Windows(1).Caption = "Jahreskalender " & kJahr
    ActiveSheet.Name = kJahr
    If kJahr Mod 4 = 0 Then n = 367 Else n = 366
    Range("A2") = DateSerial(kJahr, 1, 1)
    Range("A3").Formula = "=A2+1"
    Range("A3:A" & n).FillDown
    Range("A2:A" & n).Copy
    Range("A2:A" & n).PasteSpecial (xlValues)
    Columns(1).Copy Columns(2)
    Range("B2:B" & n).NumberFormat = "dddd"
    Range("B1") = "Tag"
    Range("B1").HorizontalAlignment = xlRight
End Sub

Private Sub Wochenende()
    Dim i%
    i = 2
    Do Until IsEmpty(Cells(i, 1))
        If WeekDay(Cells(i, 1)) = 7 Then
            Range(Cells(i, 1), Cells(i, 2)) _
                .Interior.ColorIndex = 40
        ElseIf WeekDay(Cells(i, 1)) = 1 Then
            Range(Cells(i, 1), Cells(i, 2)) _
                .Interior.ColorIndex = 3
        End If
        i = i + 1
    Loop
End Sub

Private Sub Feiertage(TB1 As Worksheet)
    Dim gZelle As Range
    Dim i%
    i = 1
    Do Until IsEmpty(TB1.Cells(i, 2))
        Set gZelle = Range("A:A").Find(DateValue _
            (TB1.Cells(i, 2)), lookin:=xlFormulas)
        With gZelle
            .Interior.ColorIndex = 4
            .Offset(0, 1).Interior.ColorIndex = 4
            .NoteText TB1.Cells(i, 1)
        End With
        i = i + 1
    Loop
End Sub

Public Function EasterDate(Yr As Integer)
    Dim D As Integer
    D = (((255 - 11 * (Yr Mod 19)) - 21) Mod 30) + 21
    EasterDate = DateSerial(Yr, 3, 1) + D + (D > 48) + _
        6 - ((Yr + Yr \ 4 + D + (D > 48) + 1) Mod 7)
End Function